import abc

from irctokens.line import Line

ILine = Line


class IServer:
    @abc.abstractmethod
    async def reply(self, line: ILine, msg: str) -> None: ...


class IPlugin:
    def __init__(self, config: dict) -> None:
        self.config = config

    @abc.abstractmethod
    async def handle(self, bot: IServer, line: ILine) -> None: ...
