from aioconsole import ainput

from .interface import IServer, ILine
from .yobot import Yobot


class Srv(IServer):
    def __init__(self, yobot: Yobot) -> None:
        self.yobot = yobot
        super().__init__()

    async def reply(self, line: ILine, msg: str) -> None:  # noqa: ARG002
        print(msg)

    async def line_read(self, msg: ILine) -> None:
        await self.yobot.handle_repl(self, msg)

    async def run(self) -> None:
        try:
            while True:
                s = await ainput("<user> ")
                await self.line_read(
                    ILine(
                        source="user",
                        tags={},
                        command="PRIVMSG",
                        params=["#test", s],
                    ),
                )
        except EOFError:
            pass


async def main(yobot: Yobot) -> None:
    await Srv(yobot).run()
